#
# Conditional build:
%bcond_without	apidocs	# Doxygen documentation
%bcond_without	qt	# wvstreams-qt library

Summary:	A network programming library written in C++
Summary(pl.UTF-8):	Biblioteka programowania sieciowego napisana w C++
Name:		wvstreams
Version:	4.6.1
Release:	12
License:	LGPL v2
Group:		Libraries
#Source0Download: http://code.google.com/p/wvstreams/downloads/list
Source0:	http://wvstreams.googlecode.com/files/%{name}-%{version}.tar.gz
# Source0-md5:	2760dac31a43d452a19a3147bfde571c
Patch0:		%{name}-sort.patch
Patch1:		%{name}-tcl.patch
Patch2:		%{name}-qt.patch
Patch3:		%{name}-openssl.patch
Patch4:		%{name}-includes.patch
Patch5:		%{name}-4.2.2-multilib.patch
Patch6:		%{name}-4.5-noxplctarget.patch
Patch7:		%{name}-4.6.1-make.patch
Patch8:		%{name}-4.6.1-gcc47.patch
Patch9:		%{name}-4.6.1-magic.patch
Patch10:	gcc-6.patch
Patch11:	unsigned.patch
URL:		http://alumnit.ca/wiki/index.php?page=WvStreams
BuildRequires:	autoconf >= 2.50
BuildRequires:	boost-devel
BuildRequires:	dbus-devel >= 1.2.14
%{?with_apidocs:BuildRequires:	doxygen}
BuildRequires:	libstdc++-devel
BuildRequires:	openssl-devel >= 0.9.7i
BuildRequires:	pam-devel
BuildRequires:	pkgconfig
%{?with_qt:BuildRequires:	qt-devel >= 3}
BuildRequires:	readline-devel
BuildRequires:	tcl-devel
BuildRequires:	zlib-devel
Obsoletes:	libwvstreams
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
WvStreams aims to be an efficient, secure, and easy-to-use library for
doing network applications development.

%description -l pl.UTF-8
WvStreams próbuje być wydajną, bezpieczną i łatwą w użyciu biblioteką
do tworzenia aplikacji sieciowych.

%package devel
Summary:	Development files for WvStreams
Summary(pl.UTF-8):	Pliki developerskie dla WvStreams
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	libstdc++-devel
Obsoletes:	libwvstreams-devel

%description devel
WvStreams aims to be an efficient, secure, and easy-to-use library for
doing network applications development. This package contains the
files needed for developing applications which use WvStreams.

%description devel -l pl.UTF-8
WvStreams próbuje być wydajną, bezpieczną i łatwą w użyciu biblioteką
do tworzenia aplikacji sieciowych. Pakiet ten zawiera pliki niezbędne
do kompilowania oprogramowania używającego WvStreams.

%package static
Summary:	Static WvStreams library
Summary(pl.UTF-8):	Statyczna biblioteka WvStreams
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static WvStreams library.

%description static -l pl.UTF-8
Statyczna wersja biblioteki WvStreams.

%package qt
Summary:	WvStreams interface to Qt 3 library
Summary(pl.UTF-8):	Interfejs WvStreams do biblioteki Qt 3
Group:		X11/Libraries
Requires:	%{name} = %{version}-%{release}

%description qt
WvStreams interface to Qt 3 library.

%description qt -l pl.UTF-8
Interfejs WvStreams do biblioteki Qt 3.

%package qt-devel
Summary:	WvStreams interface to Qt 3 library - development files
Summary(pl.UTF-8):	Interfejs WvStreams do biblioteki Qt 3 - pliki programistyczne
Group:		X11/Libraries
Requires:	%{name}-devel = %{version}-%{release}
Requires:	%{name}-qt = %{version}-%{release}
Requires:	qt-devel >= 3

%description qt-devel
WvStreams interface to Qt 3 library - development files.

%description qt-devel -l pl.UTF-8
Interfejs WvStreams do biblioteki Qt 3 - pliki programistyczne.

%package apidocs
Summary:	API documentation for WvStreams libraries
Summary(pl.UTF-8):	Dokumentacja API bibliotek WvStreams
Group:		Documentation
BuildArch:	noarch

%description apidocs
API documentation for WvStreams libraries.

%description apidocs -l pl.UTF-8
Dokumentacja API bibliotek WvStreams.

%package uniconfd
Summary:	Daemon for the UniConf configuration system
Summary(pl.UTF-8):	Demon dla systemu konfiguracji UniConf
Group:		Daemons
Requires:	%{name} = %{version}-%{release}

%description uniconfd
UniConf is the One True Configuration system that includes all the
others because it has plugin backends and frontends. Or, less
grandiosely, it's a lightweight, distributed, cacheable tree of
strings.

uniconfd is necessary when you have more than one application, or
multiple instances of an application, sharing one configuration.
UniConf-enabled applications contact uniconfd which provides
notifications when any of their watched keys change.

%description uniconfd -l pl.UTF-8
UniConf to system Jedynie Słusznej Konfiguracji zawierający
wszystkie inne, ponieważ ma wtyczki backendowe i frontendowe.
Mniej górnolotnie mówiąc, jest to lekkie, rozproszone, cache'owalne
drzewo łańcuchów znaków.

uniconfd jest potrzebny w przypadku korzystania z jednej konfiguracji
przez więcej niż jedną aplikację lub wiele instancji aplikacji. Wtedy
aplikacje korzystające z UniConfa kontaktują się z uniconfd, który
zapewnia powiadomienia w przypadku zmiany dowolnego z obserwowanych
kluczy.

%package -n valgrind-wvstreams
Summary:	WvStreams support for Valgrind
Summary(pl.UTF-8):	Obsługa WvStreams dla Valgrinda
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	valgrind

%description -n valgrind-wvstreams
WvStreams support for Valgrind.

%description -n valgrind-wvstreams -l pl.UTF-8
Obsługa WvStreams dla Valgrinda.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1

%build
%{__autoconf}
# disable-optimization disables -O2 override
%configure \
	--disable-optimization \
	%{!?with_qt:--without-qt}

%{__make} -j1 \
	VPATH=%{_libdir} \
	DEBUG=%{?debug:1}%{!?debug:0} \
	CXX="%{__cxx}" \
	VERBOSE=1 \
	CXXOPTS="%{rpmcxxflags} -fPIC -fpermissive -fno-strict-aliasing -fno-tree-dce -fno-optimize-sibling-calls"
	COPTS="%{rpmcflags} -fPIC -fPIC -fno-strict-aliasing"

%if %{with apidocs}
%{__make} doxygen
%endif

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc README ChangeLog
%attr(755,root,root) %{_bindir}/uni
%attr(755,root,root) %{_bindir}/wsd
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/uniconf.conf
%attr(755,root,root) %{_libdir}/libuniconf.so.*.*
%attr(755,root,root) %{_libdir}/libwvbase.so.*.*
%attr(755,root,root) %{_libdir}/libwvdbus.so.*.*
%attr(755,root,root) %{_libdir}/libwvstreams.so.*.*
%attr(755,root,root) %{_libdir}/libwvutils.so.*.*
%{_mandir}/man8/uni.8*
%dir /var/lib/uniconf

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/wvtestrun
%attr(755,root,root) %{_libdir}/libuniconf.so
%attr(755,root,root) %{_libdir}/libwvbase.so
%attr(755,root,root) %{_libdir}/libwvdbus.so
%attr(755,root,root) %{_libdir}/libwvstreams.so
%attr(755,root,root) %{_libdir}/libwvutils.so
%{_libdir}/libwvtest.a
%{_includedir}/wvstreams
%exclude %{_includedir}/wvstreams/wvqthook.h
%exclude %{_includedir}/wvstreams/wvqtstreamclone.h
%{_pkgconfigdir}/libuniconf.pc
%{_pkgconfigdir}/libwvbase.pc
%{_pkgconfigdir}/libwvdbus.pc
%{_pkgconfigdir}/libwvstreams.pc
%{_pkgconfigdir}/libwvtest.pc
%{_pkgconfigdir}/libwvutils.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libwvstatic.a

%if %{with qt}
%files qt
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libwvqt.so.*.*

%files qt-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libwvqt.so
%{_includedir}/wvstreams/wvqthook.h
%{_includedir}/wvstreams/wvqtstreamclone.h
%{_pkgconfigdir}/libwvqt.pc
%endif

%if %{with apidocs}
%files apidocs
%defattr(644,root,root,755)
%doc Docs/doxy-html/*
%endif

%files uniconfd
%defattr(644,root,root,755)
%attr(755,root,root) %{_sbindir}/uniconfd
%config(noreplace) %verify(not md5 mtime size) /var/lib/uniconf/uniconfd.ini
%{_mandir}/man8/uniconfd.8*

%files -n valgrind-wvstreams
%defattr(644,root,root,755)
%{_libdir}/valgrind/wvstreams.supp
%changelog
* Sun Oct 03 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/wvstreams.git;a=log;h=master

* Sun Oct 03 2021 Jan Rękorajski <baggins@pld-linux.org> 0eeb515
- rediff patch
- fix signed to unsigned comparison
- rel 12

* Sun Feb 28 2021 Jan Rękorajski <baggins@pld-linux.org> d32f358
- unconditional noarch subpackages

* Thu Oct 17 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> 7bb42e9
- release 11 (by relup.sh)

* Tue Sep 18 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 747cf7b
- rel 10; fix build with new gcc and with new openssl 1.1.1

* Sat Sep 15 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 16e9540
- release 9 (by relup.sh)

* Tue Oct 18 2016 Jan Rękorajski <baggins@pld-linux.org> 027ae9a
- rebuild with readline 7.0
- release 8 (by relup.sh)

* Sat Mar 28 2015 Elan Ruusamäe <glen@delfi.ee> f1ff2a2
- noarch apidocs

* Wed Dec 31 2014 Jakub Bogusz <qboosh@pld-linux.org> ce3bff3
- release 6

* Wed Dec 31 2014 Jakub Bogusz <qboosh@pld-linux.org> c87b63e
- added tcl patch (fix tcl > 8.3 detection)
- added qt patch (fix qt [3.x] detection via pkg-config), build qt interface

* Wed Dec 31 2014 Jakub Bogusz <qboosh@pld-linux.org> fc538ab
- package -uniconfd and valgrind-

* Wed Dec 24 2014 Jakub Bogusz <qboosh@pld-linux.org> aceb420
- removed obsolete cflags,mk patches
- more verbose files
- package apidocs
- disable optimizations option (C*FLAGS override with -O2)

* Wed Oct 01 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> e9f6578
- rel 5; patches from FC; use CXXOPTS flags that prevent over optimization problems - also from FC

* Fri Dec 06 2013 Jan Rękorajski <baggins@pld-linux.org> 3a6a8e8
- added headers needed for getuid()
- rel 4

* Wed Jun 01 2011 lisu <lisu@pld-linux.org> 2b582b6
- rel 3

* Tue May 31 2011 lisu <lisu@pld-linux.org> 3bda772
- more includes on linux

* Tue May 31 2011 lisu <lisu@pld-linux.org> 03c1e6f
- fixed build (patch)

* Sat Nov 13 2010 pawelz <pawelz@pld-linux.org> e2567d5
- release 2

* Sun May 16 2010 sparky <sparky@pld-linux.org> 2813fed
- BR: boost-devel, dbus-devel, pam-devel, pkgconfig, readline-devel, tcl-devel

* Sun Apr 11 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> 079b9b6
- up to 4.6.1

* Sun Apr 11 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> 52fd518
- release 2

